unit ImgTst3U;

{$ifdef Ver80} { Delphi 1.0x }
  {$define DelphiLessThan3}
{$endif}
{$ifdef Ver90} { Delphi 2.0x }
  {$define DelphiLessThan3}
{$endif}
{$ifdef Ver93} { C++ Builder 1.0x }
  {$define DelphiLessThan3}
{$endif}

interface

uses
  WinProcs, WinTypes, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DBCtrls, Db, Grids, DBGrids, DBTables, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Table1: TTable;
    DBGrid1: TDBGrid;
    DataSource1: TDataSource;
    OpenDlg: TOpenDialog;
    Table1SpeciesNo: TFloatField;
    Table1Category: TStringField;
    Table1Common_Name: TStringField;
    Table1SpeciesName: TStringField;
    Table1Lengthcm: TFloatField;
    Table1Length_In: TFloatField;
    Table1Notes: TMemoField;
    Table1Graphic: TGraphicField;
    Image1: TImage;
    procedure Button1Click(Sender: TObject);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$ifndef DelphiLessThan3}
uses
  JPEG;
{$endif}

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  if OpenDlg.Execute then
  begin
    Table1.Insert;
    Table1Graphic.LoadFromFile(OpenDlg.FileName);
    Table1Common_Name.Value :=
      ExtractFileName(OpenDlg.FileName);
    Table1.Post
  end
end;

function LoadFieldIntoBitmap(Bitmap: TBitmap; Field: TBlobField): Boolean;
begin
  Result := True;
  try
    Bitmap.Assign(Field)
  except
    Result := False
  end
end;

function LoadStreamIntoGraphic(Graphic: TGraphic; Stream: TStream): Boolean;
begin
  Result := True;
  try
    Stream.Position := 0;
    Graphic.LoadFromStream(Stream);
    { Often, an icon object will assume it represents the }
    { stock application icon if it has unknown data in it }
    if Graphic is TIcon then
      if TIcon(Graphic).Handle = LoadIcon(0, IDI_APPLICATION) then
      begin
        Graphic.Assign(nil);
        Abort
      end
  except
    Result := False
  end
end;

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
var
  BlobStream: TBlobStream;
{$ifndef DelphiLessThan3}
  JPEGImg: TJPEGImage;
{$endif}
begin
  { Only execute this code if the graphic field }
  { was modified or the record was changed }
  if not Assigned(Field) or (Field = Table1Graphic) then
    if not LoadFieldIntoBitmap(Image1.Picture.Bitmap, Table1Graphic) then
    begin
      BlobStream := TBlobStream.Create(Table1Graphic, bmRead);
      try
        { Would have used this line for the bitmap if it }
        { wasn't for Paradox-stored bitmap images }
        { if not LoadStreamIntoGraphic(Image1.Picture.Bitmap, BlobStream) then}
        if not LoadStreamIntoGraphic(Image1.Picture.Metafile, BlobStream) then
        if not LoadStreamIntoGraphic(Image1.Picture.Icon, BlobStream) then
        {$ifndef DelphiLessThan3}
        begin
          JPEGImg := TJPEGImage.Create;
          try
            { A TPicture does not have a JPEG }
            { property, so we have to make do without }
            Image1.Picture.Graphic := JPEGImg;
            LoadStreamIntoGraphic(Image1.Picture.Graphic, BlobStream)
          finally
            JPEGImg.Free
          end
        end
        {$endif}
      finally
        BlobStream.Free
      end
    end
end;

end.
