unit RDBCompU;

interface

procedure Register;

implementation

uses
  Classes, DB, DBTables, DsgnIntf, DBCompU;

type
  TDatabaseNameProperty = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValues(Proc: TGetStrProc); override;
  end;

function TDatabaseNameProperty.GetAttributes: TPropertyAttributes;
begin
  { Property editor is valid when multiple }
  { components are selected on the form designer, }
  { and it has a list of values that are sorted }
  Result := [paValueList, paSortList, paMultiSelect];
end;

procedure TDatabaseNameProperty.GetValues(Proc: TGetStrProc);
var
  I: Integer;
  Values: TStringList;
begin
  Values := TStringList.Create;
  try
    { Get aliases from BDE }
    Session.GetDatabaseNames(Values);
    { Give them individually to BDE }
    for I := 0 to Pred(Values.Count) do
      Proc(Values[I])
  finally
    Values.Free
  end
end;

procedure Register;
begin
  RegisterComponents('Clinic', [TDBTest]);
  RegisterPropertyEditor(TypeInfo(String),
    TDBTest, 'DatabaseName', TDatabaseNameProperty);
end;

end.
